Summary: Courier-IMAP server
Name: courier-imap
Version: 1.7.1
Release: 16tr
License: GPL
Group: Network/Services
Source: courier-imap-%{version}.tar.bz2
Source1: courier-imapd.init
Source2: courier-pop3d.init
Source3: courier-simapd.init
Source4: courier-pop3sd.init
Source5: courier-imapd.conf
Source6: courier-pop3d.conf
Source7: courier-simapd.conf
Source8: courier-pop3sd.conf
Patch0: courier-imap-db4.1.patch
Patch1: courier-imap-mksslcert.patch
Patch2: courier-imap-2.2.1-formatstring.patch
URL: http://www.courier-mta.org
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: /sbin/chkconfig, coreutils, sed
Requires: /sbin/restart_maybe, db4, openssl, imapd-pam
BuildRequires: coreutils, rpm >= 4.0.2, sed, gcc-c++-devel
BuildRequires: perl, db4-devel, openssl-devel
BuildRequires: pam-devel openldap-devel mysql-devel postgresql-devel
Provides: imapd

%define authdaemondir /var/spool/authdaemon/courier-imap
%define sslcachedir /var/spool/courier
%define sslcache %{sslcachedir}/sslcache

%description
Courier-IMAP is an IMAP server for Maildir mailboxes.  This package contains
the standalone version of the IMAP server that's included in the Courier
mail server package.  This package is a standalone version for use with
other mail servers.  Do not install this package if you intend to install the
full Courier mail server.  Install the Courier package instead.

%package ldap
Summary: Courier-IMAP LDAP authentication driver.
Group: Network/Services
Requires: %{name} = %{version}
Requires: openldap-libs

%description ldap
This package contains the necessary files to allow Courier-IMAP to
authenticate from an LDAP directory.  Install this package if you need
the ability to use an LDAP directory for authentication.

%package mysql
Summary: Courier-IMAP MySQL authentication driver.
Group: Network/Services
Requires: %{name} = %{version}
Requires: mysql-libs

%description mysql
This package contains the necessary files to allow Courier-IMAP to
authenticate using a MySQL database table.  Install this package if you need
the ability to use a MySQL database table for authentication.

%package pgsql
Summary: Courier-IMAP PostgreSQL authentication driver.
Group: Network/Services
Requires: %{name} = %{version}
Requires: postgresql-libs

%description pgsql
This package contains the necessary files to allow Courier-IMAP to
authenticate using a PostgreSQL database table.  Install this package if you
need the ability to use a PostgreSQL database table for authentication.


%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
%configure --localstatedir=%{_localstatedir} \
           --with-authdaemonvar=%{authdaemondir} \
           --enable-unicode \
           --with-db=db \
           --disable-root-check \
           --sysconfdir=%{_sysconfdir}/%{name} \
           --libexecdir=%{_prefix}/%{_lib}/%{name} \
           --datadir=%{_datadir}/%{name} \
           --with-piddir=/var/run

make

%install
[ -n "$RPM_BUILD_ROOT" -a "RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_initdir}
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/%{name}
make install-strip DESTDIR=$RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT/%{sslcachedir}

install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_initdir}/courier-imapd
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_initdir}/courier-pop3d
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{_initdir}/courier-simapd
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{_initdir}/courier-pop3sd


#
# Fix authdaemonrc.dist
#
pushd $RPM_BUILD_ROOT%{_sysconfdir}/%{name}


# Force the use of pam by default
sed -e 's|^authmodulelist=.*|authmodulelist="authpam"|' \
    < authdaemonrc.dist > authdaemonrc.dist.tmp
mv authdaemonrc.dist.tmp authdaemonrc.dist

chmod 400 *.dist
popd


install -m 755 sysconftool $RPM_BUILD_ROOT%{_datadir}/%{name}/sysconftool
echo %{_sysconfdir}/%{name}/authdaemonrc.dist \
	> $RPM_BUILD_ROOT%{_datadir}/%{name}/configlist

echo %{_sysconfdir}/%{name}/authldaprc.dist > \
    $RPM_BUILD_ROOT%{_datadir}/%{name}/configlist.ldap
echo %{_sysconfdir}/%{name}/authmysqlrc.dist > \
    $RPM_BUILD_ROOT%{_datadir}/%{name}/configlist.mysql
echo %{_sysconfdir}/%{name}/authpgsqlrc.dist > \
    $RPM_BUILD_ROOT%{_datadir}/%{name}/configlist.pgsql

chmod 644 $RPM_BUILD_ROOT%{_datadir}/%{name}/configlist*

install -d -m 700 $RPM_BUILD_ROOT/%{authdaemondir}/
install -m 600 /dev/null $RPM_BUILD_ROOT/%{authdaemondir}/lock
install -m 600 /dev/null $RPM_BUILD_ROOT/%{authdaemondir}/pid
authlib/authmksock $RPM_BUILD_ROOT/%{authdaemondir}/socket
chmod 777 $RPM_BUILD_ROOT/%{authdaemondir}/socket

mkdir -p $RPM_BUILD_ROOT/etc/openldap/schema
install -m 444 authlib/authldap.schema \
    $RPM_BUILD_ROOT/etc/openldap/schema/courier.schema

mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/run
touch $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/authdaemonrc
install %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/imapd
install %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/pop3d
install %{SOURCE7} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/imapd-ssl
install %{SOURCE8} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/pop3d-ssl
for i in authdaemonrc imapd imapd-ssl pop3d pop3d-ssl ; do
    touch $RPM_BUILD_ROOT%{_localstatedir}/run/${i}.pid
    touch $RPM_BUILD_ROOT%{_localstatedir}/run/${i}.pid.lock
    chmod 600 $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/$i
done

# fix the document names
cp imap/README README.imap
cp maildir/README.maildirquota.txt README.maildirquota
cp maildir/README.sharedfolders.txt README.sharedfolders


%post
if [ "$1" = "0" ] ; then
    /sbin/chkconfig --add courier-imapd
    /sbin/chkconfig --add courier-simapd
    /sbin/chkconfig --add courier-pop3d
    /sbin/chkconfig --add courier-pop3sd
fi
%{_datadir}/%{name}/sysconftool `cat %{_datadir}/%{name}/configlist` \
    > /dev/null 2>&1
/sbin/restart_maybe courier-imapd
/sbin/restart_maybe courier-simapd
/sbin/restart_maybe courier-pop3d
/sbin/restart_maybe courier-pop3sd

%post ldap
%{_datadir}/%{name}/sysconftool `cat %{_datadir}/%{name}/configlist.ldap` \
    > /dev/null 2>&1

%post mysql
%{_datadir}/%{name}/sysconftool `cat %{_datadir}/%{name}/configlist.mysql` \
    > /dev/null 2>&1

%post pgsql
%{_datadir}/%{name}/sysconftool `cat %{_datadir}/%{name}/configlist.pgsql` \
    > /dev/null 2>&1

%preun
if [ "$1" = "0" ] ; then
    /sbin/service courier-imapd status > /dev/null
    if [ "$?" = "0" ]; then
	    /sbin/service courier-imapd stop
    fi
    /sbin/service courier-simapd status > /dev/null
    if [ "$?" = "0" ]; then
	    /sbin/service courier-simapd stop
    fi
    /sbin/service courier-pop3d status > /dev/null
    if [ "$?" = "0" ]; then
	    /sbin/service courier-pop3d stop
    fi
    /sbin/service courier-pop3sd status > /dev/null
    if [ "$?" = "0" ]; then
	    /sbin/service courier-pop3sd stop
    fi
    rm -f %{sslcache}
    /sbin/chkconfig --del courier-imapd
    /sbin/chkconfig --del courier-simapd
    /sbin/chkconfig --del courier-pop3d
    /sbin/chkconfig --del courier-pop3sd
fi


%clean
[ -n "$RPM_BUILD_ROOT" -a "RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root)
%doc AUTHORS COPYING imap/BUGS README README.imap README.maildirquota
%doc imap/FAQ imap/FAQ.html README.sharedfolders authlib/README.*
%doc INSTALL

%{_initdir}/*

%dir    %{_sysconfdir}/%{name}
%config(noreplace)  %{_sysconfdir}/%{name}/imapd
%config(noreplace)  %{_sysconfdir}/%{name}/imapd-ssl
%config(noreplace)  %{_sysconfdir}/%{name}/pop3d
%config(noreplace)  %{_sysconfdir}/%{name}/pop3d-ssl
%config %{_sysconfdir}/%{name}/quotawarnmsg.example
#%config %{_sysconfdir}/%{name}/imap*.dist
#%config %{_sysconfdir}/%{name}/pop3d*.dist

        %{_bindir}/*
        %{_sbindir}/*
%dir    %{_datadir}/%{name}
        %{_datadir}/%{name}/configlist
        %{_datadir}/%{name}/makeuserdb
        %{_datadir}/%{name}/mkimapdcert
        %{_datadir}/%{name}/mkpop3dcert
        %{_datadir}/%{name}/pw2userdb
        %{_datadir}/%{name}/sysconftool
        %{_datadir}/%{name}/userdb
        %{_datadir}/%{name}/vchkpw2userdb
%dir    %{_prefix}/%{_lib}/%{name}
        %{_prefix}/%{_lib}/%{name}/imapd.rc
        %{_prefix}/%{_lib}/%{name}/makedatprog
        %{_prefix}/%{_lib}/%{name}/couriertcpd
        %{_prefix}/%{_lib}/%{name}/courierlogger
        %{_prefix}/%{_lib}/%{name}/imapd-ssl.rc
        %{_prefix}/%{_lib}/%{name}/pop3d.rc
        %{_prefix}/%{_lib}/%{name}/pop3d-ssl.rc

%ghost  /var/run/*.pid
%ghost  /var/run/*.lock

%dir    %{_prefix}/%{_lib}/%{name}/authlib
        %{_prefix}/%{_lib}/%{name}/authlib/authdaemon
        %{_prefix}/%{_lib}/%{name}/authlib/authdaemond
        %{_prefix}/%{_lib}/%{name}/authlib/authdaemond.plain
%config(noreplace) %{_sysconfdir}/%{name}/authdaemonrc.dist
%ghost  %{_sysconfdir}/%{name}/authdaemonrc
%dir    %{authdaemondir}
%dir    %{sslcachedir}
%ghost  %{authdaemondir}/*

%{_mandir}/man1/*
%{_mandir}/man7/*
%{_mandir}/man8/*


%files ldap
%defattr(-,root,root)
                   %{_prefix}/%{_lib}/%{name}/authlib/authdaemond.ldap
%config(noreplace) /etc/openldap/schema/courier.schema
%config(noreplace)            %{_sysconfdir}/%{name}/authldaprc.dist
%config(noreplace)            %{_datadir}/%{name}/configlist.ldap


%files mysql
%defattr(-,root,root)
        %{_prefix}/%{_lib}/%{name}/authlib/authdaemond.mysql
%config(noreplace) %{_sysconfdir}/%{name}/authmysqlrc.dist
%config(noreplace) %{_datadir}/%{name}/configlist.mysql


%files pgsql
%defattr(-,root,root)
        %{_prefix}/%{_lib}/%{name}/authlib/authdaemond.pgsql
%config(noreplace) %{_sysconfdir}/%{name}/authpgsqlrc.dist
%config(noreplace) %{_datadir}/%{name}/configlist.pgsql


%changelog
* Fri Aug 27 2004 Erlend Midttun <erlendbm at trustix dot org> 1.7.1-16tr
- Now longer force stop of programs unless total reinstall.

* Tue Aug 24 2004 Oystein Viggen <oysteivi at trustix dot com> 2.2.1-15tr
- Fix format string vulnerability in debug.c (CAN-2004-0777)

* Fri Oct 31 2003 Chr. Toldnes <christht at trustix dot org> 1.7.1-14tr
- Backport of configs to trustix

* Sat Oct  4 2003 Chr. Toldnes <christht at trustix dot com> 1.7.1-13tsl
- A hole lot of noreplace missing.

* Sun Sep 28 2003 Chr. Toldnes <christht at trustix dot com> 1.7.1-12tsl
- port of configs to tawie

* Wed Jun 25 2003 Frode Ramsvik <froder at trustix dot com> 1.7.1-11tr
- Default location for SSL-certificates is now /etc/ssl/certs

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 1.7.1-10tr
- Big rebuild

* Fri Jun 13 2003 Chr. Toldnes <christht at trustix dot com> 1.7.1-9ct
- Make silent about perl locale issue during install :)

* Fri Jun 13 2003 Chr. Toldnes <christht at trustix dot com> 1.7.1-8ct
- the simap and pop3 scripts was swapped during install.

* Thu Jun 12 2003 Chr. Toldnes <christht at trustix dot com> 1.7.1-7ct
- Added status function in initscritps
- Added check for services is already running

* Thu Jun 12 2003 Chr. Toldnes <christht at trustix dot com> 1.7.1-6ct
- new initscript layout. one script for each service.
- separate sources for config files.
- user makes ssl certs
- ssl cert generation works

* Fri Jun  6 2003 Gerald Dachs <gda at trustix dot org> 1.7.1-5gd
- removed usage of /etc/sysconfig/rc from initscript
- activated start of the services

* Mon May 26 2003 Erlend Midttun <erlendbm at trustix dot com> 1.7.1-4em
- fileutils, textutils, sh-utils -> coreutils

* Mon May 12 2003 Erlend Midttun <erlendbm at trustix dot com> 1.7.1-3em
- Now use /usr/lib instead of /usr/libexec
- Now use /var/spool/authdaemon/courier-imap instead of /var/auth...
- Now use /var/spool/courier instead of /var/tls...
- %ghost the generated config files.
- Use PAM only by default.

* Thu Mar 27 2003 Erlend Midttun <erlendbm at trustix dot com> 1.7.1-2em
- enhanced kenr's patch to enable build both against Berkeley DB 4.0 and 4.1

* Wed Mar 26 2003 Erlend Midttun <erlendbm at trustix dot com> 1.7.1-1em
- kenr made a patch to use Berkeley DB 4.1

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 1.6.2-7em
- Rebuilt against glibc 2.3.2.

* Thu Mar 20 2003 Erlend Midttun <erlendbm at trustix dot com> 1.6.2-6em
- rebuilt against PostgreSQL 7.3.2.

* Fri Jan 31 2003 Erlend Midttun <erlendbm at trustix dot com> 1.6.2-5em
- rebuilt against openssl 0.9.7.

* Wed Jan 29 2003 Goetz Bock <bock at trustix dot org> 1.6.2-4bg
- fixed typo in courier.initd to make stop call stop() not start()

* Mon Jan 27 2003 Erlend Midttun <erlendbm at trustix dot com> 1.6.2-3em
- Now requires imapd-pam package rather than provide the files.

* Sat Jan 18 2003 Gerald Dachs <gda at trustix dot org> 1.6.2-2gd
- rebuilt against openssl 0.9.7-1gd

* Wed Jan 15 2003 Goetz Bock <bock at trustix dot org> 1.6.2-1bg
- new upstream: 1.6.2
- rewrote SPEC file
- rewrote /etc/init.d/courier-imap

* Sun Sep 22 2002 Gerald Dachs <gda at trustix dot org> 1.5.2-3gd
- Rebuild against openldap 2.1.3

* Tue Sep 10 2002 Erlend Midttun <erlendbm at trustix dot com> 1.5.2-2em
- Fixed startup script.

* Tue Aug 20 2002 Gerald Dachs <gda at trustix dot org> 1.5.2-1gd
- .spec file based on original courier .spec file
